Index: c/src/lib/libbsp/arm/lpc32xx/console/console-config.c
===================================================================
--- c/src/lib/libbsp/arm/lpc32xx/console/console-config.c	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/arm/lpc32xx/console/console-config.c	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -8,10 +8,11 @@
 
 /*
- * Copyright (c) 2009
- * embedded brains GmbH
- * Obere Lagerstr. 30
- * D-82178 Puchheim
- * Germany
- * <rtems@embedded-brains.de>
+ * Copyright (c) 2009-2014 embedded brains GmbH.  All rights reserved.
+ *
+ *  embedded brains GmbH
+ *  Dornierstr. 4
+ *  82178 Puchheim
+ *  Germany
+ *  <rtems@embedded-brains.de>
  *
  * The license and distribution terms for this file may be
@@ -20,5 +21,4 @@
  */
 
-#include <libchip/serial.h>
 #include <libchip/ns16550.h>
 
@@ -26,6 +26,6 @@
 #include <bsp/lpc32xx.h>
 #include <bsp/irq.h>
-
-extern const console_fns lpc32xx_hsu_fns;
+#include <bsp/hsu.h>
+#include <bsp/console-termios.h>
 
 static uint8_t lpc32xx_uart_get_register(uintptr_t addr, uint8_t i)
@@ -44,5 +44,5 @@
 
 #ifdef LPC32XX_UART_3_BAUD
-  static bool lpc32xx_uart_probe_3(int minor)
+  static bool lpc32xx_uart_probe_3(rtems_termios_device_context *context)
   {
     LPC32XX_UARTCLK_CTRL |= BSP_BIT32(0);
@@ -50,10 +50,10 @@
     LPC32XX_UART_CLKMODE = BSP_FLD32SET(LPC32XX_UART_CLKMODE, 0x2, 4, 5);
 
-    return true;
+    return ns16550_probe(context);
   }
 #endif
 
 #ifdef LPC32XX_UART_4_BAUD
-  static bool lpc32xx_uart_probe_4(int minor)
+  static bool lpc32xx_uart_probe_4(rtems_termios_device_context *context)
   {
     volatile lpc32xx_gpio *gpio = &lpc32xx.gpio;
@@ -69,10 +69,10 @@
     LPC32XX_UART_CLKMODE = BSP_FLD32SET(LPC32XX_UART_CLKMODE, 0x2, 6, 7);
 
-    return true;
+    return ns16550_probe(context);
   }
 #endif
 
 #ifdef LPC32XX_UART_6_BAUD
-  static bool lpc32xx_uart_probe_6(int minor)
+  static bool lpc32xx_uart_probe_6(rtems_termios_device_context *context)
   {
     /* Bypass the IrDA modulator/demodulator */
@@ -83,5 +83,5 @@
     LPC32XX_UART_CLKMODE = BSP_FLD32SET(LPC32XX_UART_CLKMODE, 0x2, 10, 11);
 
-    return true;
+    return ns16550_probe(context);
   }
 #endif
@@ -89,156 +89,137 @@
 /* FIXME: Console selection */
 
-console_tbl Console_Configuration_Ports [] = {
+#ifdef LPC32XX_UART_5_BAUD
+static ns16550_context lpc32xx_uart_context_5 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 5"),
+  .get_reg = lpc32xx_uart_get_register,
+  .set_reg = lpc32xx_uart_set_register,
+  .port = LPC32XX_BASE_UART_5,
+  .irq = LPC32XX_IRQ_UART_5,
+  .clock = 16 * LPC32XX_UART_5_BAUD,
+  .initial_baud = LPC32XX_UART_5_BAUD
+};
+#endif
+
+#ifdef LPC32XX_UART_3_BAUD
+static ns16550_context lpc32xx_uart_context_3 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 3"),
+  .get_reg = lpc32xx_uart_get_register,
+  .set_reg = lpc32xx_uart_set_register,
+  .port = LPC32XX_BASE_UART_3,
+  .irq = LPC32XX_IRQ_UART_3,
+  .clock = 16 * LPC32XX_UART_3_BAUD,
+  .initial_baud = LPC32XX_UART_3_BAUD
+};
+#endif
+
+#ifdef LPC32XX_UART_4_BAUD
+static ns16550_context lpc32xx_uart_context_4 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 4"),
+  .get_reg = lpc32xx_uart_get_register,
+  .set_reg = lpc32xx_uart_set_register,
+  .port = LPC32XX_BASE_UART_4,
+  .irq = LPC32XX_IRQ_UART_4,
+  .clock = 16 * LPC32XX_UART_4_BAUD,
+  .initial_baud = LPC32XX_UART_4_BAUD
+};
+#endif
+
+#ifdef LPC32XX_UART_6_BAUD
+static ns16550_context lpc32xx_uart_context_6 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 6"),
+  .get_reg = lpc32xx_uart_get_register,
+  .set_reg = lpc32xx_uart_set_register,
+  .port = LPC32XX_BASE_UART_6,
+  .irq = LPC32XX_IRQ_UART_6,
+  .clock = 16 * LPC32XX_UART_6_BAUD,
+  .initial_baud = LPC32XX_UART_6_BAUD
+};
+#endif
+
+#ifdef LPC32XX_UART_1_BAUD
+static lpc32xx_hsu_context lpc32xx_uart_context_1 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 1"),
+  .hsu = (volatile lpc32xx_hsu *) LPC32XX_BASE_UART_1,
+  .irq = LPC32XX_IRQ_UART_1,
+  .initial_baud = LPC32XX_UART_1_BAUD
+};
+#endif
+
+#ifdef LPC32XX_UART_2_BAUD
+static lpc32xx_hsu_context lpc32xx_uart_context_2 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 2"),
+  .hsu = (volatile lpc32xx_hsu *) LPC32XX_BASE_UART_2,
+  .irq = LPC32XX_IRQ_UART_2,
+  .initial_baud = LPC32XX_UART_2_BAUD
+};
+#endif
+
+#ifdef LPC32XX_UART_7_BAUD
+static lpc32xx_hsu_context lpc32xx_uart_context_7 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 7"),
+  .hsu = (volatile lpc32xx_hsu *) LPC32XX_BASE_UART_7,
+  .irq = LPC32XX_IRQ_UART_7,
+  .initial_baud = LPC32XX_UART_7_BAUD
+};
+#endif
+
+const console_device console_device_table[] = {
   #ifdef LPC32XX_UART_5_BAUD
     {
-      .sDeviceName = "/dev/ttyS5",
-      .deviceType = SERIAL_NS16550,
-      .pDeviceFns = &ns16550_fns,
-      .deviceProbe = NULL,
-      .pDeviceFlow = NULL,
-      .ulMargin = 16,
-      .ulHysteresis = 8,
-      .pDeviceParams = (void *) LPC32XX_UART_5_BAUD,
-      .ulCtrlPort1 = LPC32XX_BASE_UART_5,
-      .ulCtrlPort2 = 0,
-      .ulDataPort = LPC32XX_BASE_UART_5,
-      .getRegister = lpc32xx_uart_get_register,
-      .setRegister = lpc32xx_uart_set_register,
-      .getData = NULL,
-      .setData = NULL,
-      .ulClock = 16 * LPC32XX_UART_5_BAUD,
-      .ulIntVector = LPC32XX_IRQ_UART_5
+      .device_file = "/dev/ttyS5",
+      .probe = console_device_probe_default,
+      .handler = &ns16550_handler_interrupt,
+      .context = &lpc32xx_uart_context_5.base
     },
   #endif
   #ifdef LPC32XX_UART_3_BAUD
     {
-      .sDeviceName = "/dev/ttyS3",
-      .deviceType = SERIAL_NS16550,
-      .pDeviceFns = &ns16550_fns,
-      .deviceProbe = lpc32xx_uart_probe_3,
-      .pDeviceFlow = NULL,
-      .ulMargin = 16,
-      .ulHysteresis = 8,
-      .pDeviceParams = (void *) LPC32XX_UART_3_BAUD,
-      .ulCtrlPort1 = LPC32XX_BASE_UART_3,
-      .ulCtrlPort2 = 0,
-      .ulDataPort = LPC32XX_BASE_UART_3,
-      .getRegister = lpc32xx_uart_get_register,
-      .setRegister = lpc32xx_uart_set_register,
-      .getData = NULL,
-      .setData = NULL,
-      .ulClock = 16 * LPC32XX_UART_3_BAUD,
-      .ulIntVector = LPC32XX_IRQ_UART_3
+      .device_file = "/dev/ttyS3",
+      .probe = lpc32xx_uart_probe_3,
+      .handler = &ns16550_handler_interrupt,
+      .context = &lpc32xx_uart_context_3.base
     },
   #endif
   #ifdef LPC32XX_UART_4_BAUD
     {
-      .sDeviceName = "/dev/ttyS4",
-      .deviceType = SERIAL_NS16550,
-      .pDeviceFns = &ns16550_fns,
-      .deviceProbe = lpc32xx_uart_probe_4,
-      .pDeviceFlow = NULL,
-      .ulMargin = 16,
-      .ulHysteresis = 8,
-      .pDeviceParams = (void *) LPC32XX_UART_4_BAUD,
-      .ulCtrlPort1 = LPC32XX_BASE_UART_4,
-      .ulCtrlPort2 = 0,
-      .ulDataPort = LPC32XX_BASE_UART_4,
-      .getRegister = lpc32xx_uart_get_register,
-      .setRegister = lpc32xx_uart_set_register,
-      .getData = NULL,
-      .setData = NULL,
-      .ulClock = 16 * LPC32XX_UART_4_BAUD,
-      .ulIntVector = LPC32XX_IRQ_UART_4
+      .device_file = "/dev/ttyS4",
+      .probe = lpc32xx_uart_probe_4,
+      .handler = &ns16550_handler_interrupt,
+      .context = &lpc32xx_uart_context_4.base
     },
   #endif
   #ifdef LPC32XX_UART_6_BAUD
     {
-      .sDeviceName = "/dev/ttyS6",
-      .deviceType = SERIAL_NS16550,
-      .pDeviceFns = &ns16550_fns,
-      .deviceProbe = lpc32xx_uart_probe_6,
-      .pDeviceFlow = NULL,
-      .ulMargin = 16,
-      .ulHysteresis = 8,
-      .pDeviceParams = (void *) LPC32XX_UART_6_BAUD,
-      .ulCtrlPort1 = LPC32XX_BASE_UART_6,
-      .ulCtrlPort2 = 0,
-      .ulDataPort = LPC32XX_BASE_UART_6,
-      .getRegister = lpc32xx_uart_get_register,
-      .setRegister = lpc32xx_uart_set_register,
-      .getData = NULL,
-      .setData = NULL,
-      .ulClock = 16 * LPC32XX_UART_6_BAUD,
-      .ulIntVector = LPC32XX_IRQ_UART_6
+      .device_file = "/dev/ttyS6",
+      .probe = lpc32xx_uart_probe_6,
+      .handler = &ns16550_handler_interrupt,
+      .context = &lpc32xx_uart_context_6.base
     },
   #endif
   #ifdef LPC32XX_UART_1_BAUD
     {
-      .sDeviceName = "/dev/ttyS1",
-      .deviceType = SERIAL_CUSTOM,
-      .pDeviceFns = &lpc32xx_hsu_fns,
-      .deviceProbe = NULL,
-      .pDeviceFlow = NULL,
-      .ulMargin = 16,
-      .ulHysteresis = 8,
-      .pDeviceParams = (void *) LPC32XX_UART_1_BAUD,
-      .ulCtrlPort1 = LPC32XX_BASE_UART_1,
-      .ulCtrlPort2 = 0,
-      .ulDataPort = 0,
-      .getRegister = NULL,
-      .setRegister = NULL,
-      .getData = NULL,
-      .setData = NULL,
-      .ulClock = 16,
-      .ulIntVector = LPC32XX_IRQ_UART_1
+      .device_file = "/dev/ttyS1",
+      .probe = lpc32xx_hsu_probe,
+      .handler = &lpc32xx_hsu_fns,
+      .context = &lpc32xx_uart_context_1.base
     },
   #endif
   #ifdef LPC32XX_UART_2_BAUD
     {
-      .sDeviceName = "/dev/ttyS2",
-      .deviceType = SERIAL_CUSTOM,
-      .pDeviceFns = &lpc32xx_hsu_fns,
-      .deviceProbe = NULL,
-      .pDeviceFlow = NULL,
-      .ulMargin = 16,
-      .ulHysteresis = 8,
-      .pDeviceParams = (void *) LPC32XX_UART_2_BAUD,
-      .ulCtrlPort1 = LPC32XX_BASE_UART_2,
-      .ulCtrlPort2 = 0,
-      .ulDataPort = 0,
-      .getRegister = NULL,
-      .setRegister = NULL,
-      .getData = NULL,
-      .setData = NULL,
-      .ulClock = 16,
-      .ulIntVector = LPC32XX_IRQ_UART_2
+      .device_file = "/dev/ttyS2",
+      .probe = lpc32xx_hsu_probe,
+      .handler = &lpc32xx_hsu_fns,
+      .context = &lpc32xx_uart_context_2.base
     },
   #endif
   #ifdef LPC32XX_UART_7_BAUD
     {
-      .sDeviceName = "/dev/ttyS7",
-      .deviceType = SERIAL_CUSTOM,
-      .pDeviceFns = &lpc32xx_hsu_fns,
-      .deviceProbe = NULL,
-      .pDeviceFlow = NULL,
-      .ulMargin = 16,
-      .ulHysteresis = 8,
-      .pDeviceParams = (void *) LPC32XX_UART_7_BAUD,
-      .ulCtrlPort1 = LPC32XX_BASE_UART_7,
-      .ulCtrlPort2 = 0,
-      .ulDataPort = 0,
-      .getRegister = NULL,
-      .setRegister = NULL,
-      .getData = NULL,
-      .setData = NULL,
-      .ulClock = 16,
-      .ulIntVector = LPC32XX_IRQ_UART_7
-    },
-  #endif
-};
-
-#define LPC32XX_UART_COUNT \
-  (sizeof(Console_Configuration_Ports) / sizeof(Console_Configuration_Ports [0]))
-
-unsigned long Console_Configuration_Count = LPC32XX_UART_COUNT;
+      .device_file = "/dev/ttyS7",
+      .probe = lpc32xx_hsu_probe,
+      .handler = &lpc32xx_hsu_fns,
+      .context = &lpc32xx_uart_context_7.base
+    },
+  #endif
+};
+
+const size_t console_device_count = RTEMS_ARRAY_SIZE(console_device_table);
Index: c/src/lib/libbsp/arm/lpc32xx/console/hsu.c
===================================================================
--- c/src/lib/libbsp/arm/lpc32xx/console/hsu.c	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/arm/lpc32xx/console/hsu.c	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -8,10 +8,11 @@
 
 /*
- * Copyright (c) 2010
- * embedded brains GmbH
- * Obere Lagerstr. 30
- * D-82178 Puchheim
- * Germany
- * <rtems@embedded-brains.de>
+ * Copyright (c) 2010-2014 embedded brains GmbH.  All rights reserved.
+ *
+ *  embedded brains GmbH
+ *  Dornierstr. 4
+ *  82178 Puchheim
+ *  Germany
+ *  <rtems@embedded-brains.de>
  *
  * The license and distribution terms for this file may be
@@ -20,22 +21,8 @@
  */
 
-#include <rtems.h>
-#include <rtems/libio.h>
-#include <rtems/termiostypes.h>
-
-#include <libchip/serial.h>
-#include <libchip/sersupp.h>
-
 #include <bsp.h>
 #include <bsp/lpc32xx.h>
 #include <bsp/irq.h>
-
-typedef struct {
-  uint32_t fifo;
-  uint32_t level;
-  uint32_t iir;
-  uint32_t ctrl;
-  uint32_t rate;
-} lpc32xx_hsu;
+#include <bsp/hsu.h>
 
 #define HSU_FIFO_SIZE 64
@@ -61,52 +48,27 @@
 #define HSU_IIR_MASK 0x7U
 
-static int lpc32xx_hsu_first_open(int major, int minor, void *arg)
-{
-  rtems_libio_open_close_args_t *oca = arg;
-  struct rtems_termios_tty *tty = oca->iop->data1;
-  console_tbl *ct = Console_Port_Tbl [minor];
-  console_data *cd = &Console_Port_Data [minor];
-  volatile lpc32xx_hsu *hsu = (volatile lpc32xx_hsu *) ct->ulCtrlPort1;
-
-  cd->termios_data = tty;
-  rtems_termios_set_initial_baud(tty, (int32_t) ct->pDeviceParams);
-  hsu->ctrl = HSU_CTRL_RX_INTR_ENABLED;
-
-  return 0;
-}
-
-static ssize_t lpc32xx_hsu_write(int minor, const char *buf, size_t len)
-{
-  console_tbl *ct = Console_Port_Tbl [minor];
-  console_data *cd = &Console_Port_Data [minor];
-  volatile lpc32xx_hsu *hsu = (volatile lpc32xx_hsu *) ct->ulCtrlPort1;
-  size_t tx_level = (hsu->level & HSU_LEVEL_TX_MASK) >> HSU_LEVEL_TX_SHIFT;
-  size_t tx_free = HSU_FIFO_SIZE - tx_level;
-  size_t i = 0;
-  size_t out = len > tx_free ? tx_free : len;
-
-  for (i = 0; i < out; ++i) {
-    hsu->fifo = buf [i];
-  }
-
-  if (len > 0) {
-    cd->pDeviceContext = (void *) out;
-    cd->bActive = true;
-    hsu->ctrl = HSU_CTRL_RX_AND_TX_INTR_ENABLED;
-  }
-
-  return 0;
+bool lpc32xx_hsu_probe(rtems_termios_device_context *base)
+{
+  lpc32xx_hsu_context *ctx = (lpc32xx_hsu_context *) base;
+  volatile lpc32xx_hsu *hsu = ctx->hsu;
+
+  hsu->ctrl = HSU_CTRL_INTR_DISABLED;
+
+  /* Drain FIFOs */
+  while (hsu->level != 0) {
+    hsu->fifo;
+  }
+
+  return true;
 }
 
 static void lpc32xx_hsu_interrupt_handler(void *arg)
 {
-  int minor = (int) arg;
-  console_tbl *ct = Console_Port_Tbl [minor];
-  console_data *cd = &Console_Port_Data [minor];
-  volatile lpc32xx_hsu *hsu = (volatile lpc32xx_hsu *) ct->ulCtrlPort1;
+  rtems_termios_tty *tty = arg;
+  lpc32xx_hsu_context *ctx = rtems_termios_get_device_context(tty);
+  volatile lpc32xx_hsu *hsu = ctx->hsu;
 
   /* Iterate until no more interrupts are pending */
   do {
-    int chars_to_dequeue = (int) cd->pDeviceContext;
     int rv = 0;
     int i = 0;
@@ -126,47 +88,95 @@
       }
     }
-    rtems_termios_enqueue_raw_characters(cd->termios_data, buf, i);
+    rtems_termios_enqueue_raw_characters(tty, buf, i);
 
     /* Dequeue transmitted characters */
-    cd->pDeviceContext = 0;
-    rv = rtems_termios_dequeue_characters(cd->termios_data, chars_to_dequeue);
+    rv = rtems_termios_dequeue_characters(tty, (int) ctx->chars_in_transmission);
     if (rv == 0) {
       /* Nothing to transmit */
-      cd->bActive = false;
-      hsu->ctrl = HSU_CTRL_RX_INTR_ENABLED;
-      hsu->iir = HSU_IIR_TX;
     }
   } while ((hsu->iir & HSU_IIR_MASK) != 0);
 }
 
-static void lpc32xx_hsu_initialize(int minor)
-{
-  console_tbl *ct = Console_Port_Tbl [minor];
-  console_data *cd = &Console_Port_Data [minor];
-  volatile lpc32xx_hsu *hsu = (volatile lpc32xx_hsu *) ct->ulCtrlPort1;
-
-  hsu->ctrl = HSU_CTRL_INTR_DISABLED;
-
-  cd->bActive = false;
-  cd->pDeviceContext = 0;
-
-  /* Drain FIFOs */
-  while (hsu->level != 0) {
-    hsu->fifo;
-  }
-
-  rtems_interrupt_handler_install(
-    ct->ulIntVector,
+static bool lpc32xx_hsu_first_open(
+  struct rtems_termios_tty *tty,
+  rtems_termios_device_context *base,
+  struct termios *term,
+  rtems_libio_open_close_args_t *args
+)
+{
+  lpc32xx_hsu_context *ctx = (lpc32xx_hsu_context *) base;
+  volatile lpc32xx_hsu *hsu = ctx->hsu;
+  rtems_status_code sc;
+  bool ok;
+
+  sc = rtems_interrupt_handler_install(
+    ctx->irq,
     "HSU",
     RTEMS_INTERRUPT_UNIQUE,
     lpc32xx_hsu_interrupt_handler,
-    (void *) minor
+    tty
   );
-}
-
-static int lpc32xx_hsu_set_attributes(int minor, const struct termios *term)
-{
-  console_tbl *ct = Console_Port_Tbl [minor];
-  volatile lpc32xx_hsu *hsu = (volatile lpc32xx_hsu *) ct->ulCtrlPort1;
+  ok = sc == RTEMS_SUCCESSFUL;
+
+  if (ok) {
+    rtems_termios_set_initial_baud(tty, ctx->initial_baud);
+    hsu->ctrl = HSU_CTRL_RX_INTR_ENABLED;
+  }
+
+  return ok;
+}
+
+static void lpc32xx_hsu_last_close(
+  struct rtems_termios_tty *tty,
+  rtems_termios_device_context *base,
+  rtems_libio_open_close_args_t *args
+)
+{
+  lpc32xx_hsu_context *ctx = (lpc32xx_hsu_context *) base;
+  volatile lpc32xx_hsu *hsu = ctx->hsu;
+
+  hsu->ctrl = HSU_CTRL_INTR_DISABLED;
+
+  rtems_interrupt_handler_remove(
+    ctx->irq,
+    lpc32xx_hsu_interrupt_handler,
+    tty
+  );
+}
+
+static void lpc32xx_hsu_write(
+  rtems_termios_device_context *base,
+  const char *buf,
+  size_t len
+)
+{
+  lpc32xx_hsu_context *ctx = (lpc32xx_hsu_context *) base;
+  volatile lpc32xx_hsu *hsu = ctx->hsu;
+  size_t tx_level = (hsu->level & HSU_LEVEL_TX_MASK) >> HSU_LEVEL_TX_SHIFT;
+  size_t tx_free = HSU_FIFO_SIZE - tx_level;
+  size_t i = 0;
+  size_t out = len > tx_free ? tx_free : len;
+
+  for (i = 0; i < out; ++i) {
+    hsu->fifo = buf [i];
+  }
+
+  ctx->chars_in_transmission = out;
+
+  if (len > 0) {
+    hsu->ctrl = HSU_CTRL_RX_AND_TX_INTR_ENABLED;
+  } else {
+    hsu->ctrl = HSU_CTRL_RX_INTR_ENABLED;
+    hsu->iir = HSU_IIR_TX;
+  }
+}
+
+static bool lpc32xx_hsu_set_attributes(
+  rtems_termios_device_context *base,
+  const struct termios *term
+)
+{
+  lpc32xx_hsu_context *ctx = (lpc32xx_hsu_context *) base;
+  volatile lpc32xx_hsu *hsu = ctx->hsu;
   int baud_flags = term->c_cflag & CBAUD;
 
@@ -187,16 +197,12 @@
   }
 
-  return 0;
-}
-
-const console_fns lpc32xx_hsu_fns = {
-  .deviceProbe = libchip_serial_default_probe,
-  .deviceFirstOpen = lpc32xx_hsu_first_open,
-  .deviceLastClose = NULL,
-  .deviceRead = NULL,
-  .deviceWrite = lpc32xx_hsu_write,
-  .deviceInitialize = lpc32xx_hsu_initialize,
-  .deviceWritePolled = NULL,
-  .deviceSetAttributes = lpc32xx_hsu_set_attributes,
-  .deviceOutputUsesInterrupts = true
+  return true;
+}
+
+const rtems_termios_device_handler lpc32xx_hsu_fns = {
+  .first_open = lpc32xx_hsu_first_open,
+  .last_close = lpc32xx_hsu_last_close,
+  .write = lpc32xx_hsu_write,
+  .set_attributes = lpc32xx_hsu_set_attributes,
+  .mode = TERMIOS_IRQ_DRIVEN
 };
Index: c/src/lib/libbsp/arm/lpc32xx/include/hsu.h
===================================================================
--- c/src/lib/libbsp/arm/lpc32xx/include/hsu.h	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
+++ c/src/lib/libbsp/arm/lpc32xx/include/hsu.h	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -0,0 +1,68 @@
+/**
+ * @file
+ *
+ * @ingroup lpc32xx_hsu
+ *
+ * @brief HSU support API.
+ */
+
+/*
+ * Copyright (c) 2010-2014 embedded brains GmbH.  All rights reserved.
+ *
+ *  embedded brains GmbH
+ *  Dornierstr. 4
+ *  82178 Puchheim
+ *  Germany
+ *  <rtems@embedded-brains.de>
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.org/license/LICENSE.
+ */
+
+#ifndef LIBBSP_ARM_LPC32XX_HSU_H
+#define LIBBSP_ARM_LPC32XX_HSU_H
+
+#include <rtems/termiostypes.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+/**
+ * @defgroup lpc32xx_hsu HSU Support
+ *
+ * @ingroup arm_lpc32xx
+ *
+ * @brief HSU Support
+ *
+ * @{
+ */
+
+typedef struct {
+  uint32_t fifo;
+  uint32_t level;
+  uint32_t iir;
+  uint32_t ctrl;
+  uint32_t rate;
+} lpc32xx_hsu;
+
+typedef struct {
+  rtems_termios_device_context base;
+  volatile lpc32xx_hsu *hsu;
+  size_t chars_in_transmission;
+  rtems_vector_number irq;
+  uint32_t initial_baud;
+} lpc32xx_hsu_context;
+
+extern const rtems_termios_device_handler lpc32xx_hsu_fns;
+
+bool lpc32xx_hsu_probe(rtems_termios_device_context *base);
+
+/** @} */
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /* LIBBSP_ARM_LPC32XX_HSU_H */
Index: c/src/lib/libbsp/arm/lpc32xx/preinstall.am
===================================================================
--- c/src/lib/libbsp/arm/lpc32xx/preinstall.am	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/arm/lpc32xx/preinstall.am	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -147,4 +147,8 @@
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/boot.h
 
+$(PROJECT_INCLUDE)/bsp/hsu.h: include/hsu.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/hsu.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/hsu.h
+
 $(PROJECT_INCLUDE)/bsp/i2c.h: include/i2c.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
 	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/i2c.h
Index: c/src/lib/libbsp/powerpc/gen83xx/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/Makefile.am	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/powerpc/gen83xx/Makefile.am	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -83,10 +83,8 @@
 
 # console
-libbsp_a_SOURCES += ../../shared/console.c \
-        ../../shared/console_select.c \
-	console/console-config.c \
-        ../../shared/console_read.c \
-        ../../shared/console_write.c \
-        ../../shared/console_control.c
+libbsp_a_SOURCES += ../../shared/console-termios-init.c
+libbsp_a_SOURCES += ../../shared/console-termios.c
+libbsp_a_SOURCES += console/console-config.c
+
 # bsp_i2c
 libbsp_a_SOURCES += i2c/i2c_init.c
Index: c/src/lib/libbsp/powerpc/gen83xx/console/console-config.c
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/console/console-config.c	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/powerpc/gen83xx/console/console-config.c	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -6,8 +6,8 @@
 
 /*
- * Copyright (c) 2008, 2010 embedded brains GmbH.  All rights reserved.
+ * Copyright (c) 2008-2014 embedded brains GmbH.  All rights reserved.
  *
  *  embedded brains GmbH
- *  Obere Lagerstr. 30
+ *  Dornierstr. 4
  *  82178 Puchheim
  *  Germany
@@ -21,26 +21,19 @@
 #include <rtems/bspIo.h>
 
-#include <libchip/serial.h>
 #include <libchip/ns16550.h>
-#include "../../../shared/console_private.h"
 
 #include <mpc83xx/mpc83xx.h>
 
-#include <bspopts.h>
+#include <bsp.h>
 #include <bsp/irq.h>
+#include <bsp/console-termios.h>
 
-#ifdef BSP_USE_UART2
-  #define PORT_COUNT 2
+#ifdef BSP_USE_UART_INTERRUPTS
+  #define DEVICE_FNS &ns16550_handler_interrupt
 #else
-  #define PORT_COUNT 1
+  #define DEVICE_FNS &ns16550_handler_polled
 #endif
 
-#ifdef BSP_USE_UART_INTERRUPTS
-  #define DEVICE_FNS &ns16550_fns
-#else
-  #define DEVICE_FNS &ns16550_fns_polled
-#endif
-
-static uint8_t gen83xx_console_get_register(uint32_t addr, uint8_t i)
+static uint8_t gen83xx_console_get_register(uintptr_t addr, uint8_t i)
 {
   volatile uint8_t *reg = (volatile uint8_t *) addr;
@@ -49,75 +42,70 @@
 }
 
-static void gen83xx_console_set_register(uint32_t addr, uint8_t i, uint8_t val)
+static void gen83xx_console_set_register(uintptr_t addr, uint8_t i, uint8_t val)
 {
   volatile uint8_t *reg = (volatile uint8_t *) addr;
 
-  reg [i] = val; 
+  reg [i] = val;
 }
 
-unsigned long Console_Configuration_Count = PORT_COUNT;
+static ns16550_context gen83xx_uart_context_0 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 0"),
+  .get_reg = gen83xx_console_get_register,
+  .set_reg = gen83xx_console_set_register,
+  .port = (uintptr_t) &mpc83xx.duart[0],
+#if MPC83XX_CHIP_TYPE / 10 == 830
+   .irq = BSP_IPIC_IRQ_UART,
+#else
+   .irq = BSP_IPIC_IRQ_UART1,
+#endif
+  .initial_baud = BSP_CONSOLE_BAUD
+};
 
-console_tbl Console_Configuration_Ports [PORT_COUNT] = {
+#ifdef BSP_USE_UART2
+static ns16550_context gen83xx_uart_context_1 = {
+  .base = RTEMS_TERMIOS_DEVICE_CONTEXT_INITIALIZER("UART 1"),
+  .get_reg = gen83xx_console_get_register,
+  .set_reg = gen83xx_console_set_register,
+  .port = (uintptr_t) &mpc83xx.duart[1],
+#if MPC83XX_CHIP_TYPE / 10 == 830
+  .irq = BSP_IPIC_IRQ_UART,
+#else
+  .irq = BSP_IPIC_IRQ_UART2,
+#endif
+  .initial_baud = BSP_CONSOLE_BAUD
+};
+#endif
+
+const console_device console_device_table[] = {
   {
-    .sDeviceName = "/dev/ttyS0",
-    .deviceType = SERIAL_NS16550,
-    .pDeviceFns = DEVICE_FNS,
-    .deviceProbe = NULL,
-    .pDeviceFlow = NULL,
-    .ulMargin = 16,
-    .ulHysteresis = 8,
-    .pDeviceParams = (void *) BSP_CONSOLE_BAUD,
-    .ulCtrlPort1 = (uint32_t) &mpc83xx.duart [0],
-    .ulCtrlPort2 = 0,
-    .ulDataPort =  (uint32_t) &mpc83xx.duart [0],
-    .getRegister = gen83xx_console_get_register,
-    .setRegister = gen83xx_console_set_register,
-    .getData = NULL,
-    .setData = NULL,
-    .ulClock = 0,
-#if MPC83XX_CHIP_TYPE / 10 == 830
-    .ulIntVector = BSP_IPIC_IRQ_UART
-#else
-    .ulIntVector = BSP_IPIC_IRQ_UART1
-#endif
+    .device_file = "/dev/ttyS0",
+    .probe = ns16550_probe,
+    .handler = DEVICE_FNS,
+    .context = &gen83xx_uart_context_0.base
   }
 #ifdef BSP_USE_UART2
   , {
-    .sDeviceName = "/dev/ttyS1",
-    .deviceType = SERIAL_NS16550,
-    .pDeviceFns = DEVICE_FNS,
-    .deviceProbe = NULL,
-    .pDeviceFlow = NULL,
-    .ulMargin = 16,
-    .ulHysteresis = 8,
-    .pDeviceParams = (void *) BSP_CONSOLE_BAUD,
-    .ulCtrlPort1 = (uint32_t) &mpc83xx.duart [1],
-    .ulCtrlPort2 = 0,
-    .ulDataPort =  (uint32_t) &mpc83xx.duart [1],
-    .getRegister = gen83xx_console_get_register,
-    .setRegister = gen83xx_console_set_register,
-    .getData = NULL,
-    .setData = NULL,
-    .ulClock = 0,
-#if MPC83XX_CHIP_TYPE / 10 == 830
-    .ulIntVector = BSP_IPIC_IRQ_UART
-#else
-    .ulIntVector = BSP_IPIC_IRQ_UART2
-#endif
+    .device_file = "/dev/ttyS1",
+    .probe = ns16550_probe,
+    .handler = DEVICE_FNS,
+    .context = &gen83xx_uart_context_1.base
   }
 #endif
 };
 
+const size_t console_device_count = RTEMS_ARRAY_SIZE(console_device_table);
+
 static void gen83xx_output_char(char c)
 {
-  const console_fns *console = Console_Port_Tbl [Console_Port_Minor]->pDeviceFns;
-  
+  rtems_termios_device_context *ctx = console_device_table[0].context;
+
   if (c == '\n') {
-    console->deviceWritePolled((int) Console_Port_Minor, '\r');
+    ns16550_polled_putchar(ctx, '\r');
   }
-  console->deviceWritePolled((int) Console_Port_Minor, c);
+
+  ns16550_polled_putchar(ctx, c);
 }
 
-BSP_output_char_function_type  BSP_output_char = gen83xx_output_char;
+BSP_output_char_function_type BSP_output_char = gen83xx_output_char;
 
 BSP_polling_getchar_function_type BSP_poll_char = NULL;
Index: c/src/lib/libbsp/powerpc/gen83xx/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/startup/bspstart.c	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/powerpc/gen83xx/startup/bspstart.c	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -8,10 +8,11 @@
 
 /*
- * Copyright (c) 2008
- * Embedded Brains GmbH
- * Obere Lagerstr. 30
- * D-82178 Puchheim
- * Germany
- * rtems@embedded-brains.de
+ * Copyright (c) 2008-2014 embedded brains GmbH.  All rights reserved.
+ *
+ *  embedded brains GmbH
+ *  Dornierstr. 4
+ *  82178 Puchheim
+ *  Germany
+ *  <info@embedded-brains.de>
  *
  * The license and distribution terms for this file may be
@@ -22,5 +23,5 @@
 #include <rtems/counter.h>
 
-#include <libchip/serial.h>
+#include <libchip/ns16550.h>
 
 #include <libcpu/powerpc-utility.h>
@@ -32,4 +33,5 @@
 #include <bsp/linker-symbols.h>
 #include <bsp/u-boot.h>
+#include <bsp/console-termios.h>
 
 /* Configuration parameters for console driver, ... */
@@ -55,4 +57,5 @@
 
   rtems_interrupt_disable(level);
+  (void) level;
 
   printk("%s PANIC %s\n", rtems_get_version_string(), s);
@@ -68,4 +71,5 @@
 
   rtems_interrupt_disable( level);
+  (void) level;
 
   printk( "%s PANIC ERROR %u\n", rtems_get_version_string(), n);
@@ -81,13 +85,10 @@
   unsigned long i = 0;
 
-  ppc_cpu_id_t myCpu;
-  ppc_cpu_revision_t myCpuRevision;
-
   /*
    * Get CPU identification dynamically. Note that the get_ppc_cpu_type() function
    * store the result in global variables so that it can be used latter...
    */
-  myCpu = get_ppc_cpu_type();
-  myCpuRevision = get_ppc_cpu_revision();
+  get_ppc_cpu_type();
+  get_ppc_cpu_revision();
 
   /* Basic CPU initialization */
@@ -123,10 +124,11 @@
 
   /* Initialize some console parameters */
-  for (i = 0; i < Console_Configuration_Count; ++i) {
-    Console_Configuration_Ports [i].ulClock = BSP_bus_frequency;
+  for (i = 0; i < console_device_count; ++i) {
+    ns16550_context *ctx = (ns16550_context *) console_device_table[i].context;
+
+    ctx->clock = BSP_bus_frequency;
 
     #ifdef HAS_UBOOT
-      Console_Configuration_Ports [i].pDeviceParams =
-        (void *) bsp_uboot_board_info.bi_baudrate;
+      ctx->initial_baud = bsp_uboot_board_info.bi_baudrate;
     #endif
   }
Index: c/src/lib/libbsp/powerpc/qoriq/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/qoriq/Makefile.am	(revision d5cc923fea9568bfb7af7e4404b6438281ed69db)
+++ c/src/lib/libbsp/powerpc/qoriq/Makefile.am	(revision 6ec438e8a323cf623cdaecce6f2b3b52b062881a)
@@ -93,13 +93,9 @@
 
 # Console
-libbsp_a_SOURCES += ../../shared/console.c \
-        ../../shared/console_select.c \
-	console/uart-bridge-master.c \
-	console/uart-bridge-slave.c \
-	console/console-config.c \
-        ../../shared/console_read.c \
-        ../../shared/console_write.c \
-        ../../shared/console_control.c
-
+libbsp_a_SOURCES += ../../shared/console-termios-init.c
+libbsp_a_SOURCES += ../../shared/console-termios.c
+libbsp_a_SOURCES += console/uart-bridge-master.c
+libbsp_a_SOURCES += console/uart-bridge-slave.c
+libbsp_a_SOURCES += console/console-config.c
 
 # RTC
